<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <!-- responsive meta tags -->
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Bootstrap Grid System</title>

    <!-- bootstrap css -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
</head>
<body>

    <h1 class="text-center text-white bg-danger">Bootstrap Grid System</h1>
    <div class="container-fluid">
        <div class="row">
            <!-- div column can occupy more than 1 column. We may create layouts wherein one div occupies 8 columns and another occupies 4
            But as you may see, it results to 12 columns for our row. If the divs in a row, occupy more than 12 columns, the row would overflow and put the rest of the divs on the next line.

            Syntax to define the number of columns a div will occupy in a row:

            col-breakpoint-numberOfColumns
            (must not exceed 12 to avoid overflow)
            -->
            <div class="bg-primary border border-dark col-md-8">
                Lorem ipsum dolor sit, amet consectetur adipisicing elit. Veritatis eaque unde quo quasi maxime veniam error. Ducimus animi dicta debitis iste eligendi repudiandae placeat, sit nulla ratione libero impedit, cumque accusantium praesentium laborum quisquam, exercitationem harum perspiciatis nostrum distinctio? Voluptates beatae molestias commodi optio omnis, atque amet magni natus repellendus.
            </div>
            <div class="bg-danger border border-dark col-md-6">
                Lorem ipsum dolor, sit amet consectetur adipisicing elit. Ducimus reprehenderit dolor tenetur necessitatibus sunt. Labore magnam doloribus vitae accusantium perspiciatis ab expedita est beatae! Ex enim exercitationem et ratione pariatur architecto sit aliquam! Ipsa natus deserunt fugiat dolores perspiciatis delectus molestiae tempore, quo culpa laboriosam, quos, at placeat! Quos, impedit.
            </div>
        </div>
    </div>

    <!-- container -->
    <div class="container bg-dark">
        <h2 class="text-center">Row in Container</h2>
        <div class="row">
            <div class="col-6 border border-dark bg-primary">
                6 columns out of 12
            </div>
            <div class="col-6 border border-dark bg-danger">
                6 columns out of 12
            </div>
        </div>
    </div>

    <!-- CRC -->
    <!-- uneven columns -->
    <div class="container-fluid bg-secondary mt-5">
        <h2 class="text-center text-white">Uneven Columns</h2>
    
    <div class="row">
        <div class="col-6 border border-dark bg-success">
            6 columns out of 12
        </div>
        <div class="col-3 border border-dark bg-info">
            3 columns out of 12
        </div>
        <div class="col-3 border border-dark bg-danger">
            3 columns out of 12
        </div>
    </div>
    </div>


    <div class="container-fluid bg-secondary mt-5">
        <h2 class="text-center text-white">Uneven Columns</h2>
    <div class="row">
        <div class="col-6 border border-dark bg-success">
            3 columns out of 12
        </div>
        <div class="col-3 border border-dark bg-info">
            6 columns out of 12
        </div>
        <div class="col-3 border border-dark bg-danger">
            3 columns out of 12
        </div>
    </div>
    </div>


    <div class="container-fluid bg-secondary mt-5">
        <h2 class="text-center text-white">Uneven Columns</h2>
    <div class="row">
        <div class="col-3 border border-dark bg-success">
            3 columns out of 12
        </div>
        <div class="col-3 border border-dark bg-info">
            3 columns out of 12
        </div>
    </div>
    </div>



    <!-- Mini Activity -->
    <!-- <div class="container-fluid bg-secondary mt-5">
        <h2 class="text-center text-white">Mini Activity</h2> -->
    <div class="row mt-5">
        <div class="col-8 border border-dark bg-primary">
            8 out of 12
        </div>
        <div class="col-2 border border-dark bg-danger">
            2 out of 12
        </div>
        <div class="col-2 border border-dark bg-success">
            2 out of 12
        </div>
    </div>
    <!-- </div> -->


    <!-- Mini Activity 2 -->

    <div class="row mt-5">
        <div class="col-3 offset-2">
            <img src="https://i.pinimg.com/474x/ec/32/45/ec324549310ed4c5966ffe05f718e66c.jpg" alt="image" class="img-fluid">
        </div>
        <div class="col-5 bg-dark text-white">
            <h4>Yuyu Hakusho</h4>
            <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Totam architecto ea perspiciatis explicabo vel dolorum at, consequatur quam deserunt doloremque non, maxime aliquam qui, exercitationem consequuntur omnis possimus id pariatur!</p>
        </div>
    </div>
    <hr>
    <h2 class="text-center text-white">Offset</h2>
    <div  class="row mt-4">
        <!-- offset will allow us to offset our divs a number to the right. However, take note that when you offset columns to the right will also move -->
        <div class="col-1 bg-danger border border-dark offset-3">
            1 out of 12
        </div>
        <div class="col-2 bg-danger border border-dark offset-1">
            2 out of 12
        </div>
        <div class="col-2 bg-danger border border-dark offset-4">
            2 out of 12
        </div>
    </div>


    <!-- Mini Activity 3 -->
<div class="row mt-5">
        <div class="col-2 offset-5 mb-3">
            <img src="https://i.pinimg.com/474x/ec/32/45/ec324549310ed4c5966ffe05f718e66c.jpg" alt="image2" class="img-fluid">
        </div>
</div>
    <div class="row">
        <div class="col-2 offset-5 text-center text-success">
            <h1>Hello World</h1>
        </div>
    </div>
    <div class="row">
        <div class="col-4 offset-4 bg-secondary text-white">
            <p>
                Lorem, ipsum dolor sit amet consectetur adipisicing elit. Incidunt eius eum est minima odit? Praesentium, debitis velit amet nemo inventore hic illum et mollitia modi vero corrupti iure eligendi aliquam.
            </p>
        </div>
    </div>


    <hr>
    <h2 class="text-center mt-3">Breakpoints</h2>
    <!-- 
        Bootstrap prides itself with mobile-first development. This is why when we set our columns the effect or the size is from the smallest to the largest.
        Since, bootstrap take a mobile-first approach, the default breakpoint is for the smallest screen.

        Breakpoints are the screen where we can resize the column.
        Meaning until we add a breakpoint (sm, md, lg, xl) the number of columns a div will occupy will be the same from the smallest to the largest

        columns can be sized withnbreakpoints starting fron the small screen:

        col.* - from smallest screen
        col - sm - * breakpoint from small screen or about 576px screen width
        col - md - * - breakpoint from the medium or tablet or about 768px screen width
        col - lg - * - breakpoint from the large or laptop or about 992px screen width
        col - xl - * - breakpoint fromn the largest screen or about 1200px screen width


     -->

     <div class="row mt-5">
        <div class="col-12 col-md-3">
            <img class="img-fluid" src="https://pbs.twimg.com/profile_images/1299844050208555008/7wMQaJRA_400x400.jpg" alt="">
        </div>
        <div class="col-12 col-md-5">
            <h4>Ryan Reynolds</h4>
            <p>
                Lorem ipsum dolor sit amet consectetur adipisicing elit. Tempore est unde, deserunt dolorem quos necessitatibus ut assumenda soluta quia iure enim porro temporibus id totam incidunt exercitationem quisquam non ea sapiente? Dolore id ullam explicabo temporibus, rem veritatis facere magnam ea quas nulla, rerum voluptatum quia accusantium nostrum et in optio neque animi quaerat qui! Repellat, maxime magni quas dolore dolor id qui eaque quidem quasi error quia laudantium, labore doloribus blanditiis, voluptas earum numquam expedita deserunt consequatur inventore illum facere. Nemo repudiandae assumenda perspiciatis sequi in, a quam qui veritatis at nisi quibusdam accusantium nobis laborum necessitatibus. Repudiandae, ratione.
            </p>
        </div>
     </div>

     <!-- SAMPLE -->
     <div class="row mt-5">
         <div class="col-12 col-md-6 border border-dark bg-primary p-5">
             column 1
         </div>
         <div class="col-12 col-lg-6 border border-dark bg-success p-5">
             column2
         </div>
     </div>

     <!-- SAMPLE -->
     <div class="row mt-5">
         <div class="col-12 col-md-8 border border-dark bg-warning p-5">
            column 3
         </div>
         <div class="col-12 col-md-4 border border-dark bg-primary p-5">
            column 4
         </div>
     </div>


     <div class="row mt-5">
         <div class="col-6 col-md-3 border border-dark bg-warning p-5">
             Mini-Activity
         </div>
         <div class="col-6 col-md-3 border border-dark bg-warning p-5">
             Mini-Activity
         </div>
         <div class="col-6 col-md-3 border border-dark bg-warning p-5">
            Mini-Activity
        </div>
        <div class="col-6 col-md-3 border border-dark bg-warning p-5">
            Mini-Activity
        </div>
     </div>



     <h2 class="mt-5">Column Order</h2>
     <!-- adding order class will allow us to reorder our columns based on the screen. However, take note, that the default for order is also from the small screen. So you have to add a breakpoint to change the order of your columns in a bigger screen. -->
     <div class="row mt-5">
         <div class="col-12 col-md-4 border border-dark bg-warning p-5 order-3 order-md-1">
             Lebron James
         </div>
         <div class="col-12 col-md-4 border border-dark bg-dark p-5 text-white order-2 order-md-3">
             Kevin Durant
         </div>
         <div class="col-12 col-md-4 border border-dark bg-primary p-5 order-1 order-md-2">
             Steph Curry
         </div>
     </div>
<!-- Bootstrap js -->
     <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
     <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>

</body>
</html>